import SH.Game.Sounds;
import SGF.SceneDirector;
import SD.RD;
import SH.Server.XMLServerHelpers;
import mx.events.EventDispatcher;

//Stores reference data
class Ref{
	
	private var dispatchEvent:Function;
	private var _dispatchersSetup:Boolean = false;
	public function addEventListener():Void {}
 	public function removeEventListener():Void {}
	
	//************************************************************
	//PUBLIC REFERENCE VARS
	//************************************************************
	
	//This is for Movieclips and ref data that is structural to the project
	
	//place all global references here
	//public var localPath;
	public var host:MovieClip;
	public var GamePlay1MC:MovieClip;
	public var GamePlay2MC:MovieClip;
	public var GamePlay3MC:MovieClip;
	public var GamePlay4MC:MovieClip;
	public var GamePlay5MC:MovieClip;
	public var GamePlay6MC:MovieClip;
	public var sceneDirector:SceneDirector;
	public var gameSounds:Sounds;
	
	public var ScoreRound1:Number = 0;
	public var ScoreMissesRound2:Number = 0;
	public var RandomContestantScores:Array;
	
	
	//************************************************************
	//CONFIG XML VARS
	//************************************************************
	
	//This is or non structural reference like Strings, Number, and Array Strings reference data
	//These functions populate the ref from config.xml
	//access values via Ref.gI().config.MovieArrayString or getRef().config.MovieArrayString
	
	public var config:Object;
	
	//************************************************************
	//CONSTRUCTOR FUNCTIONS
	//************************************************************
	
	public function populateConfigRefData(xmlFilePath:String, eventLisenersArray:Array){
		
		EventDispatcher.initialize(this);
		//Setup the listeners for the e_configDataLoaded event
		for(var x = 0; x < eventLisenersArray.length; x++){

			addEventListener("e_configDataLoaded", eventLisenersArray[x]);
			
		}
		
		config = new Object();
		
		var myXMLHelp = new XMLServerHelpers();
		var xmlSuccessFunction:Function =  function(returnedXML:XML, thisObj:Object){
			
			RD.D("----------------------------------------------------------------------------------------");
			RD.D("Start Processing config.xml");
			RD.D("----------------------------------------------------------------------------------------");
			RD.D("");
			
			//runs through the config
			for (var aNode:XMLNode = returnedXML.firstChild.firstChild; aNode != null; aNode=aNode.nextSibling) {
				
				var tempValueName:String = aNode.attributes["valName"];
				var tempValueType:String = aNode.attributes["valType"];
				
				//add the String
				if(tempValueType == "String"){
					
					thisObj.config[tempValueName] = String(aNode.firstChild.nodeValue);
					
				}
				
				//add the String
				if(tempValueType == "Number"){
					
					thisObj.config[tempValueName] = Number(aNode.firstChild.nodeValue);
					
				}
				
				//add the Array
				var tempArr:Array = new Array();
				if(tempValueType == "Array"){
					
					for (var bNode:XMLNode = aNode.firstChild; bNode != null; bNode=bNode.nextSibling) {
					
						if(bNode.attributes["valType"] == "String"){
							
							tempArr.push(String(bNode.firstChild.nodeValue));
							
						}
						
						if(bNode.attributes["valType"] == "Number"){
							
							tempArr.push(Number(bNode.firstChild.nodeValue));
							
						}
					}
					//
					thisObj.config[tempValueName] = tempArr;
				}
				//
				/*if(tempValueType == "Array"){
					
					RD.D("var " + tempValueName + ":" + tempValueType + " = " + tempArr);
					
				}else{
					
					RD.D("var " + tempValueName + ":" + tempValueType + " = " + aNode.firstChild.nodeValue);
					
				}*/
				
				
				//add the Array
				var tempObj:Object = new Object();
				if(tempValueType == "Object"){
					
					for (var bNode:XMLNode = aNode.firstChild; bNode != null; bNode=bNode.nextSibling) {
					
						if(bNode.attributes["valType"] == "String"){
							
							tempObj[bNode.attributes["propertyName"]] = (String(bNode.firstChild.nodeValue));
							
						}
						
						if(bNode.attributes["valType"] == "Number"){
							
							tempObj[bNode.attributes["propertyName"]] = (Number(bNode.firstChild.nodeValue));
							
						}
					}
					//
					thisObj.config[tempValueName] = tempObj;
				}
				
			}
			
			RD.D("");
			RD.D("----------------------------------------------------------------------------------------");
			RD.D("End Processing config.xml");
			RD.D("----------------------------------------------------------------------------------------");
			RD.D("");
			
			//dispatch event that XML Data is loaded and processed
			thisObj.dispatchEvent({target:thisObj, type:"e_configDataLoaded"});

		}
		
		var xmlFailureFunction:Function =  function(){
			
			RD.D("************************SGF WARNING!****************************");
			RD.D("WARNING! Xml file failure - config.xml in REF", this);
			
		}

		myXMLHelp.loadXMLFromFile(xmlFilePath,  this, xmlSuccessFunction, xmlFailureFunction);
		
		
	}


	//private vars:
   static private var instance:Ref;
 
   private function Ref() {}
 
   public static function gI():Ref {
	   
      if (instance == undefined) {
         
			instance = new Ref();
			return instance;
			
		}else{
			
			return instance;
			
		}
	}
	
	
	
	
}